clc
close all
clear

Coverfilename = 'godcatfinal';
Msgfilename = 'Copyright1119 453';

Resultfilename = 'Result.xlsx';
T = table;
T_idx = 1;

KeyWord = 1987;
Alpha = 0.01;
%  Beta = 100000;

cover = stlread(strcat('CoverSTL\', Coverfilename, '.stl'));
msg_org = im2double(imread(strcat('Msg\', Msgfilename, '.png')));
msg = reshape(msg_org,1,size(msg_org,1)*size(msg_org,2));

% msg Encryption
rand('twister', KeyWord); 
indx1 = randperm(size(msg,2));
rand('twister', KeyWord+2); 
indx2 = randperm(size(msg,2));
rand('twister', KeyWord+6); 
indx3 = randperm(size(msg,2));

En_msg1(indx1) = msg;
En_msg2(indx2) = msg;
En_msg3(indx3) = msg;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Watermarking
    max_Curr_vertices = max(max(cover.vertices));
    min_Curr_vertices = min(min(cover.vertices));

% vertices Normalization into range [0 1]
    Normailzed_vertices = (cover.vertices - min_Curr_vertices)/(max_Curr_vertices- min_Curr_vertices);
    
% vertices preprocessing
    Normailzed_vertices(Normailzed_vertices == 0)= Alpha;
    Normailzed_vertices(Normailzed_vertices == 1)= 1- Alpha;  
    
Beta = 1000;

    % start embeding    
    Stego = cover;
    DeNormailzed_vertices = cover.vertices;
    for i = 1:size(msg,2)%size(cover.vertices,1)

        Curr_vertices = Normailzed_vertices(i,:);

        %Trans_Curr_vertices = dct(Curr_vertices);
        [cA,cD] = dwt(Curr_vertices,'haar');
        
        Trans_Curr_vertices_1 =qun2(cA(1),En_msg1(i),Beta);
        Trans_Curr_vertices_2 =qun2(cA(2),En_msg2(i),Beta);
        Trans_Curr_vertices_3 =qun1(cD(1),En_msg3(i),Beta);

        
        %Stego_vertices = idct([Trans_Curr_vertices_1 Trans_Curr_vertices_2 Trans_Curr_vertices_3]);
        Stego_vertices = idwt([Trans_Curr_vertices_1 Trans_Curr_vertices_2], [Trans_Curr_vertices_3 cD(2)],'haar');

        DeNormailzed_vertices = (Stego_vertices(1:3) * (max_Curr_vertices - min_Curr_vertices) + min_Curr_vertices);
        Stego.vertices(i,:) = DeNormailzed_vertices;
    end

    stlwrite(strcat('StegoSTL\', Coverfilename, '-Beta-', num2str(Beta), '.stl'),Stego,'TITLE', ' ');

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Extraction

    stego = stlread(strcat('StegoSTL\', Coverfilename, '-Beta-', num2str(Beta), '.stl'));

    Normailzed_vertices = (stego.vertices - min_Curr_vertices)/(max_Curr_vertices- min_Curr_vertices);

    RecMsg = zeros(size(msg,2),3);

    for i = 1:size(msg,2)%size(stego.vertices,1)

        Curr_vertices = Normailzed_vertices(i,:);

        %Trans_Curr_vertices = dct(Curr_vertices);
        [cA,cD] = dwt(Curr_vertices,'haar');

        Trans_Curr_vertices_1 =Inv_qun1(cA(1),Beta);
        Trans_Curr_vertices_2 =Inv_qun1(cA(2),Beta);
        Trans_Curr_vertices_3 =Inv_qun2(cD(1),Beta);

        RecMsg(i,:) = [Trans_Curr_vertices_1 Trans_Curr_vertices_2 Trans_Curr_vertices_3];
    end

    % Decryption
    RRmsg1 = zeros(1,size(RecMsg(:,1),1));
    RRmsg2 = zeros(1,size(RecMsg(:,1),1));
    RRmsg3 = zeros(1,size(RecMsg(:,1),1));

    for kk = 1 : size(RecMsg(:,1),1)
        RRmsg1(kk) = RecMsg(indx1(kk),1);
        RRmsg2(kk) = RecMsg(indx2(kk),2);
        RRmsg3(kk) = RecMsg(indx3(kk),3);
    end
    RRmsg1 = reshape(RRmsg1,size(msg_org,1),size(msg_org,2));
    RRmsg2 = reshape(RRmsg2,size(msg_org,1),size(msg_org,2));
    RRmsg3 = reshape(RRmsg3,size(msg_org,1),size(msg_org,2));

    imwrite(im2uint8((RRmsg1+RRmsg2+RRmsg3)/3),strcat('RecMsg\', Coverfilename, '-Beta-', num2str(Beta), '.png'))



